'use strict';

const ModulusChecker = require('../lib/ModulusChecker.js'),
    assert = require('assert');

describe('ModulusChecker', function() {

    describe('check', function() {

        describe('correct account numbers', function() {

            it('Should return true for sort code 089999 and bank account number 66374958', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('089999', '66374958'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 107999 and bank account number 88837491', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('107999', '88837491'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 202959 and bank account number 63748472', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('202959', '63748472'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 871427 and bank account number 46238510', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('871427', '46238510'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 872427 and bank account number 46238510', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('872427', '46238510'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 871427 and bank account number 09123496', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('871427', '09123496'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 871427 and bank account number 99123496', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('871427', '99123496'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 820000 and bank account number 73688637', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('820000', '73688637'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 827999 and bank account number 73988638', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('827999', '73988638'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 827101 and bank account number 28748352', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('827101', '28748352'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 134020 and bank account number 63849203', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('134020', '63849203'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 118765 and bank account number 64371389', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('118765', '64371389'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 200915 and bank account number 41011166', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('200915', '41011166'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 938611 and bank account number 42368003', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('938611', '42368003'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 938600 and bank account number 55065200', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('938600', '55065200'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 938063 and bank account number 00000190', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('938063', '00000190'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 772798 and bank account number 99345694', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('772798', '99345694'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 086090 and bank account number 06774744', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('086090', '06774744'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 309070 and bank account number 02355688', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('309070', '02355688'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 309070 and bank account number 12345668', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('309070', '12345668'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 309070 and bank account number 12345677', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('309070', '12345677'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 309070 and bank account number 99345694', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('309070', '99345694'), true, 'Should return with true');
                done();
            });

            it('Should return false for sort code 938063 and bank account number 15764273', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('938063', '15764273'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 938063 and bank account number 15764264', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('938063', '15764264'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 938063 and bank account number 15763217', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('938063', '15763217'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 118765 and bank account number 64371388', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('118765', '64371388'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 203099 and bank account number 66831036', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('203099', '66831036'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 203099 and bank account number 58716970', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('203099', '58716970'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 089999 and bank account number 66374959', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('089999', '66374959'), false, 'Should return with false');
                done();
            });

            it('Should return false for sort code 107999 and bank account number 88837493', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('107999', '88837493'), false, 'Should return with false');
                done();
            });

            it('Should return true for sort code 074456 and bank account number 12345112', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('074456', '12345112'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 070116 and bank account number 34012583', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('070116', '34012583'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 074456 and bank account number 11104102', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('074456', '11104102'), true, 'Should return with true');
                done();
            });

            it('Should return true for sort code 180002 and bank account number 00000190', function(done) {
                const modulusChecker = new ModulusChecker();

                assert.equal(modulusChecker.check('180002', '00000190'), true, 'Should return with true');
                done();
            });

        });

    });
});